#ident	"@(#) Stp.h 1.5 89/06/23 "

/*
 *	Copyright (C) The Santa Cruz Operation, 1988.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation and should be treated as Confidential.
 */

/*
 * SCSI tape driver
 *
 */

#ifdef SCSI_DEBUG
# define private
# define DPRINT(a)  printf a
#else
# define private static
# define DPRINT(a)
#endif

#define SPL spl6
#define SCT_MEMGRAN	1		/* memory granularity */
#define SCT_MAXMEM	(128*1024)	/* 128K */
#define SCT_MINMEM	(32*1024)	/* 16K */
#define SCT_MEMCHUNK	(2*1024)	/* 2K  */

struct Stp_flags_t {
	unsigned short open:1;
	unsigned short reset:1;
	unsigned short wprot:1;
	unsigned short read:1;
	unsigned short write:1;
	unsigned short filemark:1;
	unsigned short eom:1;
	unsigned short blank:1;		/* blank check error */
	unsigned short error:1;
	unsigned short active:1;
	unsigned short fixed:1;		/* fixed-length blocks */
};
extern struct Stp_flags_t Stp_flags[];
extern struct ndevbuf Stp_ndb[];
extern int Stp_dataf[],Stp_compf[];

#pragma pack(1)

struct Stp_block_descr {
	char density;
	char num_blks[3];
	char reserved;
	char blk_len[3];
};

struct Stp_mode_sense {
	unsigned char data_len;
	unsigned char medium;
	unsigned char speed:4;
	unsigned char buffered:3;
	unsigned char wprot:1;
	unsigned char bdescr_len;
	struct Stp_block_descr bdescr;
};

#pragma pack()

#define SCT_64K 0xffff
#define SCT_BSIZE 512
#define SCT_512 0x1ff
#define SCT_BMASK 0x1ff

#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)>(b))?(b):(a))
#define B_ROUND_U(dev,a) (((a)&(~Stp_bmask[DEVNO(dev)]))+(((a)&(Stp_bmask[DEVNO(dev)]))?Stp_bsize[DEVNO(dev)]:0))
#define B_ROUND_D(dev,a) ((a) & (~Stp_bmask[DEVNO(dev)]))
/* sequential access devices */

#define SCSI_S_SPACE 	0x11
#define SCSI_S_REWIND 	0x01
#define SCSI_S_READ	0x08
#define SCSI_S_WRITE	0x0a
#define SCSI_S_LOAD	0x1b
#define SCSI_S_ERASE	0x19
#define SCSI_S_WFM	0x10
#define SCSI_S_RD_BLIM	0x05
#define SCSI_S_SEEK	0x0c
#define SCSI_S_MODE_SEN	0x1a
#define SCSI_S_MODE_SEL 0x15
#define SCSI_S_TEST_RDY	0x00

#define SCT_READ   1
#define SCT_WRITE  0

#define DEVNO(dev) (minor(dev)&3)
#define NDRIVES 4

/* minor device number bit definitions */

#define	SELECT0		0x00		/* Select drive 0                    */
#define	SELECT1		0x01		/* Select drive 1                    */
#define	SELECT2		0x02		/* (unused)			     */
#define	SELECT3		0x04		/* (unused)			     */
#define	NOREWIND	0x08		/* no rewind device		     */
#define	FORMAT		0x10		/* (unused)			     */
#define ECC		0x20		/* ecc minor device                  */
#define	PIGMEM		0x40		/* (unused)			     */
#define	OVERRIDE	0x80		/* maintenance device		     */
